#include <Arduino.h>

#define PIN_OUT_R 11
#define PIN_OUT_G 10
#define PIN_OUT_B 9
#define PIN_POT_R A6
#define PIN_POT_G A5
#define PIN_POT_B A4

#define POT_MAX_VAL 1023
#define PWM_MAX_VAL 255

uint8_t test_values[][3] = {
    {255, 255, 255},
    {255, 255, 191},
    {255, 255, 255},
    {255, 255, 255},
    {0, 0, 0},
    {64, 0, 0},
    {128, 0, 0},
    {191, 0, 0},
    {255, 0, 0},
    {255, 0, 64},
    {255, 64, 64},
    {255, 128, 64},
    {255, 191, 64},
    {0, 0, 64},
    {64, 0, 64},
    {191, 0, 255},
    {255, 0, 255},
    {5, 5, 5},
    {10, 10, 10},
    {15, 15, 15},
    {20, 20, 20},
    {25, 25, 25},
    {30, 30, 30},
    {35, 35, 35},
    {40, 40, 40},
    {45, 45, 45},
    {50, 50, 50},
    {55, 55, 55},
    {60, 60, 60},
    {70, 70, 70},
    {75, 75, 75},
    {80, 80, 80},
    {85, 85, 85},
    {90, 90, 90},
    {95, 95, 95},
    {100, 100, 100},
    {105, 105, 105},
    {110, 110, 110},
    {115, 115, 115},
    {120, 120, 120},
    {125, 125, 125},
    {130, 130, 130},
    {135, 135, 135},
    {140, 140, 140},
    {145, 145, 145},
    {150, 150, 150},
    {155, 155, 155},
    {160, 160, 160},
    {165, 165, 165},
    {170, 170, 170},
    {175, 175, 175},
    {180, 180, 180},
    {185, 185, 185},
    {195, 195, 195},
    {200, 200, 200},
    {205, 205, 205},
    {210, 210, 210},
    {215, 215, 215},
    {220, 220, 220},
    {225, 225, 225},
    {230, 230, 230},
    {235, 235, 235},
    {240, 240, 240},
    {245, 245, 245},
    {250, 250, 250},
    {64, 64, 0},
    {128, 64, 0},
    {191, 64, 0},
    {255, 64, 0},
    {255, 128, 0},
    {128, 128, 0},
    {191, 128, 0},
    {64, 128, 0},
    {64, 191, 0},
    {128, 191, 0},
    {191, 191, 0},
    {255, 191, 0},
    {64, 255, 0},
    {128, 255, 0},
    {191, 255, 0},
    {255, 255, 0},
    {255, 255, 64},
    {128, 0, 64},
    {128, 64, 128},
    {0, 64, 0},
    {0, 64, 64},
    {65, 65, 65},
    {128, 64, 64},
    {191, 64, 64},
    {0, 128, 0},
    {0, 128, 64},
    {64, 128, 64},
    {128, 128, 64},
    {191, 128, 64},
    {0, 191, 0},
    {0, 191, 64},
    {64, 191, 64},
    {128, 191, 64},
    {191, 191, 64},
    {0, 255, 0},
    {0, 255, 64},
    {64, 255, 64},
    {128, 255, 64},
    {191, 255, 64},
    {0, 0, 128},
    {64, 0, 128},
    {128, 0, 128},
    {191, 0, 128},
    {255, 0, 128},
    {255, 0, 191},
    {255, 64, 191},
    {191, 0, 64},
    {191, 64, 128},
    {255, 64, 128},
    {64, 64, 128},
    {64, 128, 128},
    {191, 128, 128},
    {255, 128, 128},
    {255, 128, 191},
    {64, 191, 128},
    {128, 191, 128},
    {191, 191, 128},
    {255, 191, 128},
    {255, 191, 191},
    {64, 255, 128},
    {128, 255, 128},
    {191, 255, 128},
    {255, 255, 128},
    {64, 0, 191},
    {128, 0, 191},
    {191, 0, 191},
    {191, 64, 191},
    {191, 128, 255},
    {64, 64, 191},
    {64, 128, 255},
    {0, 64, 128},
    {0, 64, 191},
    {0, 128, 191},
    {64, 128, 191},
    {128, 128, 191},
    {191, 128, 191},
    {190, 190, 190},
    {0, 191, 191},
    {64, 191, 191},
    {128, 191, 191},
    {0, 191, 128},
    {0, 255, 128},
    {0, 255, 191},
    {64, 255, 191},
    {128, 255, 191},
    {191, 255, 191},
    {191, 255, 255},
    {64, 0, 255},
    {128, 0, 255},
    {0, 0, 191},
    {0, 0, 255},
    {0, 64, 255},
    {64, 64, 255},
    {128, 64, 255},
    {191, 64, 255},
    {255, 64, 255},
    {255, 128, 255},
    {128, 64, 191},
    {128, 128, 255},
    {0, 128, 128},
    {0, 128, 255},
    {0, 191, 255},
    {64, 191, 255},
    {128, 191, 255},
    {191, 191, 255},
    {255, 191, 255},
    {0, 255, 255},
    {64, 255, 255},
    {128, 255, 255},
    {255, 255, 255},
};
const uint8_t num_test_values = sizeof(test_values) / sizeof(test_values[0]);

void setup()
{
  Serial.begin(115200);
  Serial.println("==========================================");

  pinMode(PIN_OUT_R, OUTPUT);
  pinMode(PIN_OUT_G, OUTPUT);
  pinMode(PIN_OUT_B, OUTPUT);

  pinMode(PIN_POT_R, INPUT);
  pinMode(PIN_POT_G, INPUT);
  pinMode(PIN_POT_B, INPUT);
}

int do_pwm(int pin_pot, int pin_out)
{
  float pot = analogRead(pin_pot);
  int pwm = pot / POT_MAX_VAL * PWM_MAX_VAL;
  analogWrite(pin_out, pwm);
  return pwm;
}

void loop()
{
  int pwm_r = do_pwm(PIN_POT_R, PIN_OUT_R);
  int pwm_g = do_pwm(PIN_POT_G, PIN_OUT_G);
  int pwm_b = do_pwm(PIN_POT_B, PIN_OUT_B);
  Serial.print(pwm_r);
  Serial.print(", ");
  Serial.print(pwm_g);
  Serial.print(", ");
  Serial.print(pwm_b);
  Serial.println();
  delay(50);

  // analogWrite(PIN_OUT_R, 0);
  // analogWrite(PIN_OUT_G, 0);
  // analogWrite(PIN_OUT_B, 0);
  // Serial.println("Press enter to start");
  // while (Serial.read() < 0);
  // Serial.println("Starting");

  // for(int i=0; i<num_test_values; i++) {
  //   uint8_t *rgb = test_values[i];

  //   analogWrite(PIN_OUT_R, rgb[0]);
  //   analogWrite(PIN_OUT_G, rgb[1]);
  //   analogWrite(PIN_OUT_B, rgb[2]);

  //   Serial.print(rgb[0]);
  //   Serial.print(", ");
  //   Serial.print(rgb[1]);
  //   Serial.print(", ");
  //   Serial.print(rgb[2]);
  //   Serial.println();

  //   delay(2000);
  // }

  // Serial.println("DONE");
  // while(true);
}
